searchNodes=[{"type":"module","title":"OpenTelemetryDecorator","doc":"A function decorator for OpenTelemetry traces. Installation Add open_telemetry_decorator to your list of dependencies in mix.exs . We include the opentelemetry_api package, but you'll need to add opentelemetry yourself in order to report spans and traces. def deps do [ { :opentelemetry , &quot;~&gt; 1.2&quot; } , { :opentelemetry_exporter , &quot;~&gt; 1.4&quot; } , { :open_telemetry_decorator , &quot;~&gt; 1.2&quot; } ] end Then follow the directions for the exporter of your choice to send traces to to zipkin, honeycomb, etc. https://github.com/open-telemetry/opentelemetry-erlang/tree/main/apps/opentelemetry_zipkin Honeycomb Example config/runtime.exs api_key = Map . fetch! ( System . get_env ( ) , &quot;HONEYCOMB_KEY&quot; ) config :opentelemetry , :processors , otel_batch_processor : %{ exporter : { :opentelemetry_exporter , %{ protocol : :grpc , headers : [ { &#39;x-honeycomb-team&#39; , api_key } , { &#39;x-honeycomb-dataset&#39; , &#39;YOUR_APP_NAME&#39; } ] , endpoints : [ { :https , &#39;api.honeycomb.io&#39; , 443 , [ ] } ] } } } Usage Add use OpenTelemetryDecorator to the module, and decorate any methods you want to trace with @decorate trace(&quot;span name&quot;) . The trace decorator will automatically wrap the decorated function in an opentelemetry span with the provided name. defmodule MyApp.Worker do use OpenTelemetryDecorator @decorate trace ( &quot;worker.do_work&quot; ) def do_work ( arg1 , arg2 ) do ... doing work end end Span Attributes The trace decorator allows you to specify an includes option which gives you more flexibility with what you can include in the span attributes. Omitting the includes option with trace means no attributes will be added to the span. defmodule MyApp.Worker do use OpenTelemetryDecorator @decorate trace ( &quot;worker.do_work&quot; , include : [ :arg1 , :arg2 ] ) def do_work ( arg1 , arg2 ) do ... doing work end end The decorator uses a macro to insert code into your function at compile time to wrap the body in a new span and link it to the currently active span. In the example above, the do_work method would become something like this: def do_work ( arg1 , arg2 ) do require OpenTelemetry.Span require OpenTelemetry.Tracer parent_ctx = OpenTelemetry.Tracer . current_span_ctx ( ) OpenTelemetry.Tracer . with_span &quot;my_app.worker.do_work&quot; , %{ parent : parent_ctx } do ... doing work OpenTelemetry.Span . set_attributes ( arg1 : arg1 , arg2 : arg2 ) end end You can provide span attributes by specifying a list of variable names as atoms. This list can include... Any variables (in the top level closure) available when the function exits: defmodule MyApp.Math do use OpenTelemetryDecorator @decorate trace ( &quot;my_app.math.add&quot; , include : [ :a , :b , :sum ] ) def add ( a , b ) do sum = a + b { :ok , thing1 } end end The result of the function by including the atom :result : defmodule MyApp.Math do use OpenTelemetryDecorator @decorate trace ( &quot;my_app.math.add&quot; , include : [ :result ] ) def add ( a , b ) do sum = a + b { :ok , thing1 } end end Map/struct properties using nested lists of atoms: defmodule MyApp.Worker do use OpenTelemetryDecorator @decorate trace ( &quot;my_app.worker.do_work&quot; , include : [ [ :arg1 , :count ] , [ :arg2 , :count ] , :total ] ) def do_work ( arg1 , arg2 ) do total = arg1 . count + arg2 . count { :ok , total } end end Prefixing Span Attributes Honeycomb suggests that you namespace custom fields , specifically putting manual instrumentation under app. In order to do this, you'll configure the attr_prefix option in config/config.exs config :open_telemetry_decorator , attr_prefix : &quot;app.&quot; Changing the join character for nested attributes By default, nested attributes are joined with an underscore. However, when you have an object with underscores and a property with underscores, this can be hard to visually parse. For example, my_struct.other_struct.field , would be exported as my_struct_other_struct_field . To override this, you'll configure the attr_joiner option in config/config.exs . The default value will likely change from _ to . in a future version. config :open_telemetry_decorator , attr_joiner : &quot;.&quot; Thanks to @benregn for the examples and inspiration for these two options!","ref":"OpenTelemetryDecorator.html"},{"type":"macro","title":"OpenTelemetryDecorator.trace/1","doc":"","ref":"OpenTelemetryDecorator.html#trace/1"},{"type":"macro","title":"OpenTelemetryDecorator.trace/2","doc":"","ref":"OpenTelemetryDecorator.html#trace/2"},{"type":"function","title":"OpenTelemetryDecorator.trace/4","doc":"Decorate a function to add an OpenTelemetry trace with a named span. You can provide span attributes by specifying a list of variable names as atoms. This list can include: any variables (in the top level closure) available when the function exits, the result of the function by including the atom :result , map/struct properties using nested lists of atoms. defmodule MyApp.Worker do use OpenTelemetryDecorator @decorate trace ( &quot;my_app.worker.do_work&quot; , include : [ :arg1 , [ :arg2 , :count ] , :total , :result ] ) def do_work ( arg1 , arg2 ) do total = arg1 . count + arg2 . count { :ok , total } end end","ref":"OpenTelemetryDecorator.html#trace/4"}]